      PROGRAM MTTTDATA

C THIS PROGRAM IS USED FOR CALCULATING THERMODYNAMICS AND KINETICS 
C OF STEEL USING MT-DATA, A THERMODYNAMICS DATABASE.
C
C COPYRIGHT H.K.D.H.BHADESHIA, T.SOURMAIL AND T.OKUMURA
C
C ACCURACY IN CARBON MOLE FRACTION IS 1D-6
C
C VERSION 1.0 JUL/2003
C  FIRST PROGRAM WITHOUT AN ERROR 
C
C VERSION 2.0 AUG/2003
C  ADJUSTING FITTING PARAMETERS
C
C VERSION 2.1 AUG/2003 
C  TAKE A MISCIBILITY GAP BETWEEN CU AND FE INTO ACCOUNT
C
C
      PARAMETER (MAXCPT=20)

C TO AVOID ARGUMENT, DON'T USE THE DEFAULT FILE BELOW 
C      INCLUDE 'DIURESIS.FOR'
      
      INTEGER IMODE,IERR,N,I,J,K,CHOICE,GN
      INTEGER NACT(0:MAXCPT),MERR,J1,J5,I1
      INTEGER FCC

      CHARACTER*20 FILNAM,FIL2
      CHARACTER*20 PI,PII,FAKE
      DOUBLE PRECISION MS,BS,WS1,WS2,WS3

      INTEGER ICPT,CCPT,INIT_NO_OF_COMPONENTS,PARA
      INTEGER INIT_COMPONENT_NO
      DOUBLE PRECISION TEMP,PRESS,GM,VOLF,TTT(8)
      DOUBLE PRECISION LOWERT,UPPERT,STEP,SLOPE,SECT
      DOUBLE PRECISION COMPO(0:MAXCPT)
      DOUBLE PRECISION STOREN,DEPS,CTO(10),X(10),G(10)
      DOUBLE PRECISION WSTOREN,XBAR,A(10),GG(10),XX(10)
      DOUBLE PRECISION CC(10),SHEART,DIFFT
      DOUBLE PRECISION SHEARTT,DIFFTT
      
      DO 1 I=1,10
       X(I)=0.0D0
 1    CONTINUE


C*******************************************************
C CTO(1):INITIAL WT%C 
C CTO(2):WT%C IN NUCLEUS
C CTO(3):WT%C AT AE3 BOUNDARY
C CTO(4):WT%C IN ALPHA EQ WITH CTO(2)
C CTO(5):WT%C AT AE3' BOUNDARY (FOR WID FERRITE)
C CTO(6):WT%C IN ALPHA EQ WITH CTO(4)
C CTO(7):WT%C AT T0 BOUNDARY
C CTO(8):WT%C AT TO' BOUNDARY (FOR BAINITE)
C X:ATOMIC FRACTION OF C FOR CTO
C G(1):GN (UNIVERSAL NUCLEATION FUNCTION)
C G(2):FREE ENERGY CHANGE FOR NUCLEATION (GMAX)
C G(3):GIBBS FREE ENERGY OF GAMMA
C G(4):GIBBS FREE ENERGY OF ALPHA
C G(5):GIBBS FREE ENERGY OF PARAEQUILIBRIUM (G'+A)
C G(6):FREE ENERGY CHANGE FROM GAMMA TO ALPHA
C      (DRIVING FORCE FOR DIFFUSIONLESS GROWTH)
C G(7):FREE ENERGY CHANGE FROM GAMMA TO G'+A
C      (DRIVING FORCE FOR DIFFUSIONAL GROWTH)

      IMODE=0
      IERR=0
      FIL2='def'
      PI='BCC_A2'
      PII='FCC_A1'
      FAKE=''
      TEMP=1273.0
      PARA=3
      FCC=1
      MS=0
      BS=0
      WS1=0
      WS2=0 
      WS3=0
      GN=1

C      CALL MTDATA_RESERVE_UNIT(12)
C      CALL MTDATA_RESERVE_UNIT(13)
C      CALL MTDATA_RESERVE_UNIT(14)
      CALL MTDATA_RESERVE_UNIT(15)

C     STOREN:STORED ENERGY NEEDED FOR BAINITE
C     WSTOREN:STORED ENERGY NEEDED FOR WIDMANSTATTEN FERRITE
C     SLOP.SECT IS THE SLOPE AND INTERSECT OF GN FUNCTION.
C     DEPS IS THE ACCURACY OF GIBBS FREE ENERGY CALCULATION.
      OPEN(UNIT=1,FILE='input1.dat')
      READ(1,*) FILNAM
      READ(1,*) LOWERT
      READ(1,*) UPPERT
      READ(1,*) STEP
      READ(1,*) STOREN
      READ(1,*) WSTOREN
      READ(1,*) SLOPE
      READ(1,*) SECT
      READ(1,*) DEPS
      DO 2 I=1,8
      READ(1,*) TTT(I)
 2    CONTINUE
      CLOSE(1)

      OPEN(UNIT=15,FILE='RESULTS')

      CALL INITIALISE_MTDATA(IMODE)
      CALL SGUMEN(1)
      CALL SGUMEN(2)
      CALL MTOPTN(IMODE,'STAGE_1=NEW')
      CALL OPEN_MPI_FILE(FILNAM,FIL2,IERR)
      CALL SET_PRINT_LEVEL(-2)

      CALL READ_COMPOSITION(COMPO,CHOICE,NACT)
        WRITE(15,*) 'WEIGHT %'
        WRITE(*,*) 'WEIGHT %'
        WRITE(15,16) (COMPO(J5),J5 = 1,6)
        WRITE(15,17) (COMPO(J5),J5 = 7,12)
        WRITE(*,16) (COMPO(J5),J5 = 1,6)
        WRITE(*,17) (COMPO(J5),J5 = 7,12)

      CALL TOMOLS(COMPO,CHOICE,NACT)

C MISCIBILITY GAP EXISTS IF COPPER IS CONTAINED.
C FCC IS THE FRAG OF MISCIBILITY GAP.
      IF (COMPO(9).NE.0.0) FCC=-1 

C TO SAVE SPACE, QUIT PRINTING LOGO ANY MORE
C        CALL LOGO(15)

        WRITE(15,*) 'MOL FRACTION'
        WRITE(*,*) 'MOL FRACTION'
        WRITE(15,16) (COMPO(J5),J5 = 1,6)
        WRITE(15,17) (COMPO(J5),J5 = 7,12)
        WRITE(*,16) (COMPO(J5),J5 = 1,6)
        WRITE(*,17) (COMPO(J5),J5 = 7,12)
        WRITE(15,20)
        WRITE(*,20)
        XBAR=COMPO(12)

 16    FORMAT (6H   Fe=,F8.4,6H   Cr=,F8.4,6H   Co=,F8.4,
     & 6H   Ni=,F8.4,6H   Mo=,F8.4,6H   Mn=,F8.4)
 17    FORMAT (6H   Si=,F8.4,6H   Al=,F8.4,6H   Cu=,F8.4,
     & 6H    V=,F8.4,6H   Nb=,F8.4,6h    C=,F8.4)
 20    FORMAT('  TEMP,  GN,   GMAX,  FPRO,  FTO, ',
     & 11H  X NUCLEUS,',',6H   XEQ,',',7H     XA,
     & ',',7H    XW ,
C     &8H    XA50,
     & ',',7H    XTO,',',7H XTO400,
     & ',',7H   VOLF,',',2H  ,7H SHEART,',',6H DIFFT
c     &,5H   MS,
c     & 5H   BS,5H  WS1,5H  WS2,5H  WS3
     &)

c      PAUSE

      DO 10 TEMP=LOWERT,UPPERT,STEP
C         COMPO(CCTP)=XBAR
         CALL SET_TEMPERATURE(TEMP)

C CALCULATE GN (UNIVERSAL NUCLEATION FUNCTION)
         G(1)=SLOPE*TEMP-SECT

C CALCULATE XT0
       CALL FIND_T0(COMPO,NACT,DEPS,0.0D0,CTO,X,7,MERR)

        IF(MERR.EQ.1) THEN
        WRITE(*,*) "At temperature ",TEMP,
     & " no solution found in 100 iterations."
        GOTO 999
        ELSE
C            WRITE(12,200) TEMP,CTO(4),X(4)
        ENDIF

C CALCULATE XTO'(XTO400)
         CALL FIND_T0(COMPO,NACT,DEPS,STOREN,CTO,X,8,MERR,FCC)
         IF(MERR.EQ.1) X(8)=1D-7
C            WRITE(*,*) "At temperature ",TEMP,
C     & " no BAINITE formed"

      CCPT=INIT_COMPONENT_NO('C')
      CALL SET_INIT_COMPONENT_AMOUNT(CCPT,COMPO(CCPT))
C      WRITE(*,*) "CCPT IS",CCPT

C CALCULATE XEQ & XA & FREE ENERGY CHANGES
         CALL MOLAR_GIBBS_ENERGIES(COMPO,NACT,G,CTO,X,MERR,FCC)
         G(6)=G(3)-G(4)
         G(7)=G(5)-G(4)

         IF (MERR.EQ.1) THEN
          WRITE(*,*) "At temperature ",TEMP," only one phase."
          GOTO 999
         ELSE
          IF (G(7) .GT. -WSTOREN .OR. GN .EQ. 0) THEN
           IF (WS1 .EQ. 0) THEN 
            WS1=TEMP-STEP
           ELSE
            IF(WS2 .NE. 0) WS3=TEMP-STEP
           ENDIF
          ELSE
           IF (WS1 .NE. 0) WS2=TEMP
          ENDIF         
         IF(((G(6).GE.-STOREN).OR.(GN.EQ.0)).AND.BS.EQ.0) BS=TEMP-STEP

C            WRITE(13,200) TEMP,CTO(3),CTO(4)
C            WRITE(*,300) TEMP,G(3),G(4),G(5),G(6),G(7)
         ENDIF

         CCPT=INIT_COMPONENT_NO('C')
         CALL SET_INIT_COMPONENT_AMOUNT(CCPT,COMPO(CCPT))
C      WRITE(*,*) "CCPT IS",CCPT

C CALCULATE GN AND XN
         CALL FIND_GM(COMPO,NACT,DEPS,2,CTO,X,G,MERR,FCC)

         IF(MERR.EQ.1) THEN
            WRITE(*,*) "At temperature",TEMP,
     &      " no Gm found in 100 iterations."
         ELSE
            IF (G(2) .LT. G(1)) THEN
             GN=1
            ELSE
             GN=0
         ENDIF
C            WRITE(15,200) TEMP,CTO(1),CTO(2)
         ENDIF

C CALCULATE XEQ50 AND XA50 FOR 
       CALL FIND_WID(COMPO,NACT,DEPS,WSTOREN,G,CTO,X,MERR,FCC)
        
 
       VOLF =(X(3)-COMPO(CCPT))/(X(3)-X(4))
       CALL SHEAR(SHEART,G(2),TEMP,TTT)
       CALL DIFFU(DIFFT,G(2),TEMP,TTT)
C       CALL SHEAR(SHEARTT,G(2),TEMP,TTT)
C       CALL DIFFU(DIFFTT,G(2),TEMP,TTT)
       WRITE(15,400) TEMP,G(1),G(2),G(7),G(6),X(2),X(3),X(4),
     & X(5),
C     &X(6),
     & X(7),X(8),VOLF,SHEART,DIFFT
C     & ,MS,BS,WS1,WS2,WS3
       WRITE(*,400) TEMP,G(1),G(2),G(7),G(6),X(2),X(3),X(4),
     & X(5),
C     &X(6),
     & X(7),X(8),VOLF,SHEART,DIFFT
C     & ,MS,BS,WS1,WS2,WS3

      CALL SET_INIT_COMPONENT_AMOUNT(CCPT,COMPO(CCPT))
       IF (G(7).GT.-6d-9*COMPO(CCPT)**4+4d+8*COMPO(CCPT)**3
     & -9D+6*COMPO(CCPT)**2+3.9389D+4*COMPO(CCPT)-1.4348D+3) THEN
        IF (MS .EQ. 0) MS=TEMP-STEP
       ENDIF

 10   CONTINUE
 
C      CLOSE(12)
C      CLOSE(13)
C      CLOSE(14)

 100  FORMAT (A7,1X,A10,1X,A10)
 150  FORMAT (A7,1X,A10,1X,A10,1X,A10)
 200  FORMAT (F7.2,E12.5,E12.5,E12.5,E12.5)
 300  FORMAT (F7.2,5(1X,E12.5))
 400  FORMAT (1H ,F5.0,4(' ',F6.0),' ',D9.2,
     & ' ', F7.4, ' ', D9.2, 4(' ',F7.4),2(' ',D8.2)
c     & ,5F5.0
     & )
      WRITE(*,*) "Output written to results_T0 and results_AE3."

 999  WRITE (*,*) MS,BS,WS1,WS2,WS3
      WRITE (15,*) 'MS=  ',MS,' K'
      WRITE (15,*) 'BS=  ',BS,' K'
      WRITE (15,*) 'WS1= ',WS1,' K'
      WRITE (15,*) 'WS2= ',WS2,' K'
      WRITE (15,*) 'WS3= ',WS3,' K'
      CLOSE(15)
 
      END


C **********************************************************************
C Subroutine MOLAR_GIBBS_ENERGIES
C This subroutine finds AE3 composition for the current temperature

      SUBROUTINE MOLAR_GIBBS_ENERGIES(COMPO,NACT,G,CTO,X,MERR,FCC)
C           CALL MOLAR_GIBBS_ENERGIES(COMPO,NACT,G,CTO,X,MERR)

      PARAMETER (MAXCPT=20)

      INTEGER NACT(0:MAXCPT),MERR
      DOUBLE PRECISION COMPO(0:MAXCPT),CTO(10),X(10)

      CHARACTER*20 PI,PII,FAKE
      INTEGER ICTP,I2,FCC
      INTEGER PARA,NORM,CCPT
      INTEGER EQUIL_NO_OF_PHASES,INIT_NO_OF_COMPONENTS
      INTEGER ACT_PHASE_NO,INIT_COMPONENT_NO
      DOUBLE PRECISION COMPONENT_X_OF_PHASE,COMPONENT_W_OF_PHASE
      DOUBLE PRECISION SYSTEM_GIBBS_ENERGY,SUM_OF_COMPONENT_AMOUNT
      DOUBLE PRECISION MOLES_OF_COMPONENTS_IN_PHASE
      DOUBLE PRECISION GIBBS_ENERGY_OF_PHASE,G(10)

      PI='BCC_A2'
      PII='FCC_A1'
      FAKE=''
      PARA=3
      NORM=1
      MERR=0

      CALL ONLYNORM(PI,FAKE,FCC)
      CALL COMPUTE_EQUILIBRIUM()
c      CALL DISP_RESULT(2)
      G(3)=GIBBS_ENERGY_OF_PHASE(1)/MOLES_OF_COMPONENTS_IN_PHASE(1,2)

      CALL ONLYNORM(PII,FAKE,FCC)
      CALL COMPUTE_EQUILIBRIUM()
c      CALL DISP_RESULT(2)
      G(4)=GIBBS_ENERGY_OF_PHASE(1)/MOLES_OF_COMPONENTS_IN_PHASE(1,2)

      CCPT=INIT_COMPONENT_NO('C')
      DO 10 ICPT=1,INIT_NO_OF_COMPONENTS()
         IF (ICPT.NE.CCPT) THEN
            CALL SET_INIT_COMPONENT_CLASS(ICPT,PARA)
         ENDIF
 10   CONTINUE

      CALL ONLYNORM(PI,PII,FCC)
      CALL COMPUTE_EQUILIBRIUM()
      G(5)=SYSTEM_GIBBS_ENERGY()/SUM_OF_COMPONENT_AMOUNT()
c      CALL DISP_RESULT(2)
      IF (EQUIL_NO_OF_PHASES().LT.2) THEN
         MERR=1
      ENDIF

      I2=ACT_PHASE_NO(PII)

      CTO(3)=COMPONENT_W_OF_PHASE(CCPT,I2,2)
      X(3)=COMPONENT_X_OF_PHASE(CCPT,I2,2)

      I3=ACT_PHASE_NO(PI)

      CTO(4)=COMPONENT_W_OF_PHASE(CCPT,I3,2)
      X(4)=COMPONENT_X_OF_PHASE(CCPT,I3,2)

      END


C **********************************************************************
C Subroutine FIND_WID
C This subroutine finds COMMON TANGENT for the current temperature

      SUBROUTINE FIND_WID(COMPO,NACT,DEPS,WSTOREN,G,CTO,X,IERR,FCC)
C           CALL FIND_WID(COMPO,NACT,DEPS,WSTOREN,G,CTO,X,MERR)

      PARAMETER(MAXCPT=20,MAXIT=20)
      
      INTEGER NACT(0:MAXCPT),IERR,N,MITER2,FCC
      DOUBLE PRECISION COMPO(0:MAXCPT),WSTOREN,DEPS,CTO(10)
      DOUBLE PRECISION X(10),XBAR,G(10)
      CHARACTER*20 PI,PII,FAKE
      INTEGER INIT_COMPONENT_NO,CCPT,I1,I2,MITER,J1,J2
      DOUBLE PRECISION A(3),AA(3),CC(10),GG(10),XX(10)
      DOUBLE PRECISION GIBBS_ENERGY_OF_PHASE,GI(3),GII(3),DG(5)
      DOUBLE PRECISION MOLES_OF_COMPONENTS_IN_PHASE
      DOUBLE PRECISION COMPONENT_X_OF_PHASE,COMPONENT_W_OF_PHASE

      PI='BCC_A2'
      PII='FCC_A1'
      FAKE=''
      PARA=3
      NORM=1
    
         MITER=0
         IERR=0
         CCPT=INIT_COMPONENT_NO('C') 
         XBAR=COMPO(CCPT)

         A(1)=0.0
         A(3)=1.0

 11      A(2)=(A(1)+A(3))/2
         MITER=MITER+1
        CALL SET_INIT_COMPONENT_AMOUNT(CCPT,A(2))
        CALL MOLAR_GIBBS_ENERGIES(COMPO,NACT,GG,CC,XX,IERR,FCC)
        IF (DABS(GG(5)-GG(4)+WSTOREN).LE.DEPS.OR.MITER.GT.MAXIT) GOTO 20 
        IF ((GG(5)-GG(4)+WSTOREN).LE.0.0D0) THEN
         A(1)=A(2)
        ELSE
         A(3)=A(2)
        ENDIF
C         WRITE(*,*) A(2),GG(5)-GG(4)
        GOTO 11

c        CALL FIND_GM(COMPO,NACT,DEPS,9,CC,XX,GG,IERR)
c      IF ( DABS(GG(9)+WSTOREN).LE.DEPS .OR. MITER.GT.MAXIT ) GOTO 20
c      IF ( (GG(9)+WSTOREN) .LT. 0.0D0 ) THEN
c         A(3)=A(2)
c      ELSE
c         A(1)=A(2)
c      ENDIF
c      GOTO 11
 20    CALL SET_INIT_COMPONENT_AMOUNT(CCPT,A(2))
       CALL ONLYNORM(PII,FAKE,FCC)
       CALL COMPUTE_EQUILIBRIUM()
       CTO(5)=COMPONENT_W_OF_PHASE(CCPT,1,2)
       X(5)=COMPONENT_X_OF_PHASE(CCPT,1,2)
C      CTO(6)=CC(4)
C      X(6)=XX(4)

      CALL SET_INIT_COMPONENT_AMOUNT(CCPT,XBAR)         
      END
C **********************************************************************
C Subroutine FIND_T0
C This subroutine finds T0 composition for the current temperature

      SUBROUTINE FIND_T0(COMPO,NACT,DEPS,STOREN,CTO,X,N,IERR)

      PARAMETER(MAXCPT=20,MAXIT=100)
      
      INTEGER NACT(0:MAXCPT),IERR,N,FCC
      DOUBLE PRECISION COMPO(0:MAXCPT),STOREN,DEPS,CTO(10)
      DOUBLE PRECISION X(10)
      CHARACTER*20 PI,PII,FAKE
      INTEGER INIT_COMPONENT_NO,CCPT,I1,I2,MITER
      DOUBLE PRECISION A(3)
      DOUBLE PRECISION GIBBS_ENERGY_OF_PHASE,GI(3),GII(3),DG(3)
      DOUBLE PRECISION MOLES_OF_COMPONENTS_IN_PHASE
      DOUBLE PRECISION COMPONENT_X_OF_PHASE,COMPONENT_W_OF_PHASE

      MITER=0
      IERR=0
      PI='BCC_A2'
      PII='FCC_A1'
      FAKE=''

      I1=INIT_PHASE_NO(PI)
      I2=INIT_PHASE_NO(PII)
      CCPT=INIT_COMPONENT_NO('C')

      A(1)=0
      A(3)=0.1

 5    MITER=MITER+1
      A(2)=(A(1)+A(3))/2.0


      DO 10 J=1,3
         CALL SET_INIT_COMPONENT_AMOUNT(CCPT,A(J))
         CALL ONLYNORM(PI,FAKE,FCC)
         CALL COMPUTE_EQUILIBRIUM()
c         CALL DISP_RESULT(2)
         GI(J)=GIBBS_ENERGY_OF_PHASE(1)/
     &        MOLES_OF_COMPONENTS_IN_PHASE(1,2)
         GI(J)=GI(J)+STOREN
c         WRITE(*,*) GI(J)
         CALL ONLYNORM(PII,FAKE,FCC)
         CALL COMPUTE_EQUILIBRIUM()
c         CALL DISP_RESULT(2)
         GII(J)=GIBBS_ENERGY_OF_PHASE(1)/
     &        MOLES_OF_COMPONENTS_IN_PHASE(1,2)
c         WRITE(*,*) GII(J)
         DG(J)=GII(J)-GI(J)
 10   CONTINUE

      IF (DG(1)*DG(2).GT.0) THEN
C      have same sign ie change occurs between a(2) and a(3)
         A(1)=A(2)
      ELSE
         A(3)=A(2)
      ENDIF
c         WRITE(*,*) "DIFFERENCE FOR ",A(2)," : ",DG(2)
      
      IF (DABS(DG(2)).GT.DEPS.AND.MITER.LT.MAXIT) GOTO 5
      IF (MITER.GE.MAXIT) IERR=1
      CTO(N)=COMPONENT_W_OF_PHASE(CCPT,1,2)
      X(N)  =COMPONENT_X_OF_PHASE(CCPT,1,2)
c      WRITE(*,*) CTO

      END

C **********************************************************************
C Subroutine FIND_GM
C This subroutine finds parallel tangents for G and A

      SUBROUTINE FIND_GM(COMPO,NACT,DEPS,N,CTO,X,G,IERR,FCC)

      PARAMETER(MAXCPT=20,MAXIT=30)
      
      INTEGER NACT(0:MAXCPT),IERR,N,FCC
      DOUBLE PRECISION COMPO(0:MAXCPT),WSTOREN,DEPS,CTO(10)
      DOUBLE PRECISION X(10)
      DOUBLE PRECISION A(10),DA(10),G(10)
      DOUBLE PRECISION GI(10),GII(10),DG(10),DX

      CHARACTER*20 PI,PII,FAKE
      INTEGER INIT_COMPONENT_NO,CCPT,I1,I2,MITER
      DOUBLE PRECISION GIBBS_ENERGY_OF_PHASE
      DOUBLE PRECISION MOLES_OF_COMPONENTS_IN_PHASE
      DOUBLE PRECISION COMPONENT_X_OF_PHASE,COMPONENT_W_OF_PHASE

      MITER=0
      IERR=0
      PI='BCC_A2'
      PII='FCC_A1'
      FAKE=''
      DX=0.1D-5

      I1=INIT_PHASE_NO(PI)
      I2=INIT_PHASE_NO(PII)
      CCPT=INIT_COMPONENT_NO('C')
      
      CALL ONLYNORM(PII,FAKE,FCC)
      CALL COMPUTE_EQUILIBRIUM()

      CTO(9)=COMPONENT_W_OF_PHASE(CCPT,I2,2)
      X(9)=COMPO(CCPT)
      GII(6)=GIBBS_ENERGY_OF_PHASE(1)/MOLES_OF_COMPONENTS_IN_PHASE(1,2)

      CALL SET_INIT_COMPONENT_AMOUNT(CCPT,X(9)-DX) 
      CALL ONLYNORM(PII,FAKE,FCC)
      CALL COMPUTE_EQUILIBRIUM()
      GII(4)=GIBBS_ENERGY_OF_PHASE(1)/MOLES_OF_COMPONENTS_IN_PHASE(1,2)

      CALL SET_INIT_COMPONENT_AMOUNT(CCPT,X(9)+DX) 
      CALL ONLYNORM(PII,FAKE,FCC)
      CALL COMPUTE_EQUILIBRIUM()

      GII(5)=GIBBS_ENERGY_OF_PHASE(1)/MOLES_OF_COMPONENTS_IN_PHASE(1,2)

      DG(4)=(GII(5)-GII(4))/2.0D0/DX
      DG(5)=DEPS/2.0D0/DX

       A(1)=DX
       A(3)=0.1D0

 5    MITER=MITER+1
      A(2)=(A(1)+A(3))/2.0D0

C      DO 6 K=1,3
C        DA(K)=A(K)+DX
C 6    CONTINUE


      DO 10 J=1,3
         CALL SET_INIT_COMPONENT_AMOUNT(CCPT,A(J)-DX)
         CALL ONLYNORM(PI,FAKE,FCC)
         CALL COMPUTE_EQUILIBRIUM()
c         CALL DISP_RESULT(2)
         GI(J)=GIBBS_ENERGY_OF_PHASE(1)/
     &        MOLES_OF_COMPONENTS_IN_PHASE(1,2)
c         WRITE(*,*) GI(J)
         CALL SET_INIT_COMPONENT_AMOUNT(CCPT,A(J)+DX )
         CALL ONLYNORM(PI,FAKE,FCC)
         CALL COMPUTE_EQUILIBRIUM()
c         CALL DISP_RESULT(2)
         GII(J)=GIBBS_ENERGY_OF_PHASE(1)/
     &        MOLES_OF_COMPONENTS_IN_PHASE(1,2)

c         WRITE(*,*) GII(J)
         DG(J)=(GII(J)-GI(J))/2.0D0/DX-DG(4)
 10   CONTINUE
C      WRITE(*,*) "DIFFERENCE FOR",A(2),":",DG(2),DG(4)
C      write(*,*) GII(4),GII(5),GII(6)
c      write(*,*),GI(2),"       ",GII(2)

       IF(DG(2) .LT. 0.0) THEN
       A(1)=A(2)
       ELSE
       A(3)=A(2)
       ENDIF

      IF (A(2) .LE. 2.0D-6) THEN
       A(2)=0.11D-5
       GOTO 20
      ENDIF
      IF (DABS(DG(2)).GT. 10.0 .AND.MITER.LT.MAXIT) GOTO 5
      IF (MITER.GE.MAXIT) IERR=1

c      WRITE(*,*) CTO

  20     CALL SET_INIT_COMPONENT_AMOUNT(CCPT,A(2))
         CALL ONLYNORM(PI,FAKE,FCC)
         CALL COMPUTE_EQUILIBRIUM()
         G(N)=GIBBS_ENERGY_OF_PHASE(1)/
     &    MOLES_OF_COMPONENTS_IN_PHASE(1,2)-
     &    (GII(6)-DG(4)*(X(9)-A(2)))    
         CTO(N)=COMPONENT_W_OF_PHASE(CCPT,1,2)
         X(N)  =COMPONENT_X_OF_PHASE(CCPT,1,2)
C        WRITE(*,*) GII(6),DG(4),DG(2),X(9)
 30      END



C **********************************************************************
C Subroutine READ_COMPOSITION
C This subroutine reads data from the file.

      SUBROUTINE READ_COMPOSITION(COMPO,CHOICE,NACT)

      PARAMETER (MAXCPT=20)

      INTEGER CHOICE,NACT(0:MAXCPT)
      DOUBLE PRECISION COMPO(0:MAXCPT),CTOTAL

      CHARACTER*5 COMENT

      OPEN(UNIT=1,FILE='composition1.dat')

      I=1
      C=0.0D0
      READ(1,*)
      READ(1,*) CHOICE
 10   READ(1,*,END=20) COMPO(I)
      IF (I.NE.1) C=C+COMPO(I)
      IF (COMPO(I).EQ.0.0D0) THEN 
         NACT(I)=0
      ELSE 
         NACT(I)=1
      ENDIF
      I=I+1
      GOTO 10


 20   IF(CHOICE.EQ.1) THEN
         COMENT='mass'
      ELSE IF (CHOICE.EQ.2) THEN
         COMENT='mole'
      ENDIF

      COMPO(1)=100.0D0-C
      COMPO(0)=I-1
      WRITE(*,*) "Composition in ",COMENT," read"
      CLOSE(1)
      END


C **********************************************************************
C Subroutine ONLYNORM
C This subroutine classifies normal the phase whose names are 
C passed as arguments and absent all the others.


      SUBROUTINE ONLYNORM(PI,PII,FCC)

      CHARACTER*20 PI,PII
      CHARACTER*20 PVAR
      CHARACTER*20 INIT_PHASE_NAME
      INTEGER INIT_NO_OF_PHASES,FCC

      DO 10 I=1,INIT_NO_OF_PHASES()
         PVAR=INIT_PHASE_NAME(I)

         IF (PVAR.EQ.PI) THEN 
          IF ((FCC.EQ.-1).AND.(PI.EQ.'FCC_A1')) THEN 
            CALL SET_INIT_PHASE_CLASS(I,-1)
          ELSE
            CALL SET_INIT_PHASE_CLASS(I,1) 
          ENDIF
         ELSEIF (PVAR.EQ.PII) THEN 
          IF ((FCC.EQ.-1).AND.(PII.EQ.'FCC_A1')) THEN 
            CALL SET_INIT_PHASE_CLASS(I,-1)
          ELSE
            CALL SET_INIT_PHASE_CLASS(I,1) 
          ENDIF
         ELSE
            CALL SET_INIT_PHASE_CLASS(I,0) 
         ENDIF 
 10   CONTINUE
      END

C ********************************************************************
C Subroutine DISP_RESULT(K)
C displays the result of the last equilibrium calculation
C argument K: 1/ mass of phases and compositions in wt%
C             2/ moles of phases and compositions in mole fraction

      SUBROUTINE DISP_RESULT(K)

c      INCLUDE 'DIRUSRAP.FOR'
      

      INTEGER K,I,J,L,M,N

      CHARACTER*2  ACT_COMPONENT_NAME
      CHARACTER*10 ACT_PHASE_NAME

      INTEGER ACT_NO_OF_COMPONENTS,EQUIL_NO_OF_PHASES
      INTEGER PHASE_PRESENT_AT_EQUILIBRIUM

      DOUBLE PRECISION MASS_IN_PHASE,COMPONENT_W_OF_PHASE
      DOUBLE PRECISION MOLES_OF_COMPONENTS_IN_PHASE
      DOUBLE PRECISION COMPONENT_X_OF_PHASE

      L=ACT_NO_OF_COMPONENTS()
      WRITE(*,*) EQUIL_NO_OF_PHASES()
      WRITE(*,*)

      IF (K.EQ.1) THEN
         WRITE(*,*)'Weight and components weight fractions'
         WRITE(*,300)
         DO 10 I=1,EQUIL_NO_OF_PHASES()
            N=PHASE_PRESENT_AT_EQUILIBRIUM(I)

         IF (L.GT.5) THEN
          WRITE(*,100) ACT_PHASE_NAME(N),
     &    (ACT_COMPONENT_NAME(J), J=1,5)
          WRITE(*,200) MASS_IN_PHASE(N,2),
     &    (COMPONENT_W_OF_PHASE(J,N,2), J=1,5)
          WRITE(*,*)
         ELSE 
        WRITE(*,100) ACT_PHASE_NAME(N),
     &  (ACT_COMPONENT_NAME(J), J=1,ACT_NO_OF_COMPONENTS())
        WRITE(*,200) MASS_IN_PHASE(N,2),
     &  (COMPONENT_W_OF_PHASE(J,N,2), J=1,ACT_NO_OF_COMPONENTS())
         GOTO 21
         ENDIF

         IF (L.GT.10) THEN 
            WRITE(*,400) (ACT_COMPONENT_NAME(J),J=6,10)
            WRITE(*,500) (COMPONENT_W_OF_PHASE(J,N,2), J=6,10)
            WRITE(*,*)
         ELSE
            M=6
            GOTO 20
         ENDIF

         IF (L.GT.15) THEN 
            WRITE(*,400) (ACT_COMPONENT_NAME(J),J=11,15)
            WRITE(*,500) (COMPONENT_W_OF_PHASE(J,N,2), J=11,15)
            WRITE(*,*)
         ELSE
            M=11
            GOTO 20
         ENDIF

 20    WRITE(*,400) 
     & (ACT_COMPONENT_NAME(J), J=M,ACT_NO_OF_COMPONENTS())
       WRITE(*,500) 
     &  (COMPONENT_W_OF_PHASE(J,N,2), J=M,ACT_NO_OF_COMPONENTS())

 21    WRITE(*,300)
       WRITE(*,*)
 10      CONTINUE
      ENDIF

      IF (K.EQ.2) THEN
         WRITE(*,*)'Moles and components mole fractions'
         WRITE(*,300)
         DO 30 I=1,EQUIL_NO_OF_PHASES()
            N=PHASE_PRESENT_AT_EQUILIBRIUM(I)

         IF (L.GT.5) THEN
          WRITE(*,100) ACT_PHASE_NAME(N),
     &    (ACT_COMPONENT_NAME(J), J=1,5)
          WRITE(*,200) MOLES_OF_COMPONENTS_IN_PHASE(N,2),
     &    (COMPONENT_X_OF_PHASE(J,N,2), J=1,5)
          WRITE(*,*)
         ELSE 
          WRITE(*,100) ACT_PHASE_NAME(N),
     &    (ACT_COMPONENT_NAME(J), J=1,ACT_NO_OF_COMPONENTS())
          WRITE(*,200) MOLES_OF_COMPONENTS_IN_PHASE(N,2),
     &   (COMPONENT_X_OF_PHASE(J,N,2), J=1,ACT_NO_OF_COMPONENTS())
          GOTO 41
         ENDIF

         IF (L.GT.10) THEN 
            WRITE(*,400) (ACT_COMPONENT_NAME(J),J=6,10)
            WRITE(*,500) (COMPONENT_X_OF_PHASE(J,N,2), J=6,10)
            WRITE(*,*)
         ELSE
            M=6
            GOTO 40
         ENDIF

         IF (L.GT.15) THEN 
            WRITE(*,400) (ACT_COMPONENT_NAME(J),J=11,15)
            WRITE(*,500) (COMPONENT_X_OF_PHASE(J,N,2), J=11,15)
            WRITE(*,*)
         ELSE
            M=11
            GOTO 40
         ENDIF

 40      WRITE(*,400) 
     &   (ACT_COMPONENT_NAME(J), J=M,ACT_NO_OF_COMPONENTS())
         WRITE(*,500) 
     &   (COMPONENT_X_OF_PHASE(J,N,2), J=M,ACT_NO_OF_COMPONENTS())
 
 41      WRITE(*,300)
         WRITE(*,*)
 
 30      CONTINUE
      ENDIF

 100  FORMAT (1X,A,1X,5(5X,A,4X))
 200  FORMAT (E11.6,1X,5(1X,F9.7,1X))
 300  FORMAT (66('-'))
 400  FORMAT (12X,5(5X,A,4X))
 500  FORMAT (12X,5(1X,F9.7,1X))

      END


C *******************************************************************
C Subroutine DISP_COMPONENTS
C argument CHOICE: 1 / name of initial components
C                  2 / mass of initial components
C                  3 / moles of initial components
C                  4 / name of active components (after eq calc only)

      SUBROUTINE DISP_COMPONENTS(CHOICE)

      INTEGER CHOICE

      DOUBLE PRECISION INIT_COMPONENT_MASS
      DOUBLE PRECISION INIT_COMPONENT_MOLES
      INTEGER ACT_NO_OF_COMPONENTS
      CHARACTER*20 INIT_COMPONENT_NAME,ACT_COMPONENT_NAME

      WRITE(*,*)

      IF (CHOICE.EQ.1) THEN
      DO 10 I=1,INIT_NO_OF_COMPONENTS()
         WRITE(*,100) 'Component',I,'is',INIT_COMPONENT_NAME(I)
 10   CONTINUE
      ENDIF

      IF (CHOICE.EQ.2) THEN 
      DO 20 I=1,INIT_NO_OF_COMPONENTS()
       WRITE(*,150) INIT_COMPONENT_NAME(I),' mass: ',
     & INIT_COMPONENT_MASS(I)
 20   CONTINUE
      ENDIF

      IF(CHOICE.EQ.3) THEN
         DO 30 I=1,INIT_NO_OF_COMPONENTS()
            WRITE(*,200) 'Component',I,'amount is',
     &      INIT_COMPONENT_MOLES(I)
 30      CONTINUE
      ENDIF

      IF (CHOICE.EQ.4) THEN 
         DO 40 I=1,ACT_NO_OF_COMPONENTS()
            WRITE(*,100) 'Active Component', I, 'is',
     &       ACT_COMPONENT_NAME(I)
 40         CONTINUE
      ENDIF

 100  FORMAT (10X,A,1X,I2,1X,A,1X,A)
 150  FORMAT (10X,A,1X,A,1X,F7.4)
 200  FORMAT (10X,A,1X,I2,1X,A,1X,F7.4)
      END



C *******************************************************************
C Subroutine DISP_PHASES
C display the different phases loaded with the mpi file and their 
C current status


      SUBROUTINE DISP_PHASES()

      CHARACTER*20 INIT_PHASE_NAME
      CHARACTER*6 ANSW

      LOGICAL NORMAL_INIT_PHASE
      INTEGER INIT_NO_OF_PHASES

      WRITE(*,*)
      DO 10 I=1,INIT_NO_OF_PHASES()
         IF (NORMAL_INIT_PHASE(I)) THEN 
            ANSW='normal'
            ELSE
            ANSW='absent'
         ENDIF
         WRITE(*,100) 'The phase',INIT_PHASE_NAME(I),'is', ANSW
 10   CONTINUE
 100  FORMAT (A,1X,A,1X,A,1X,A)
      END


C**************************************************************
      SUBROUTINE LOGO(U)
      INTEGER U
      WRITE(U,432)
      WRITE(U,1)
      WRITE(U,2)
      WRITE(U,6)
      WRITE(U,2)
300   WRITE(U,2)
      WRITE(U,8)
      WRITE(U,2)
      WRITE(U,9)
      WRITE(U,10)
      WRITE(U,2)
      WRITE(U,1)
      WRITE(U,433)
432   FORMAT(//////////)
1     FORMAT(
     &10X,' *************************************************',
     &'**********')
2     FORMAT(10X,' **',55X,'**')
6     FORMAT(10X,' **',9X,' TTT DIAGRAMS FOR STEELS (MUCG2003)',11X,
     & '**')
8     FORMAT(10X,' **',8X,'                  by                  ',
     &9X,'**')
9     FORMAT(10X,' **',5X,'H.K.D.H.Bhadeshia, T.SOURMAIL AND T.OKUMURA',
     &7X,'**')
10    FORMAT(10X,' **',8X,'        University of Cambridge       ',
     &9X,'**')
433   FORMAT(////)
C     PAUSE
      RETURN
      END

C *******************************************************************
C
C This subroutine set the mass of components according to the table
C which is passed to it.
C Use WT or MOL (1 or 2) to say whether you set moles or mass.
C
C Verified !!
C                          ****************

      SUBROUTINE SETCOM(COMPO,CHOICE)

      PARAMETER (MAXCPT=20)

      DOUBLE PRECISION COMPO(0:MAXCPT)
      INTEGER CHOICE
      
      INTEGER I,INIT_NO_OF_COMPONENTS

      IF (CHOICE.EQ.1) THEN
      DO 10 I=1,INIT_NO_OF_COMPONENTS()
         CALL SET_INIT_COMPONENT_MASS(I,COMPO(I))
10    CONTINUE
      ENDIF

      IF (CHOICE.EQ.2) THEN
      DO 20 I=1,INIT_NO_OF_COMPONENTS()
         CALL SET_INIT_COMPONENT_AMOUNT(I,COMPO(I))
 20   CONTINUE
      ENDIF

      END



C *******************************************************************
C
C Perform a 'dummy' calculation to convert to mole fractions

      SUBROUTINE TOMOLS(COMPO,CHOICE,NACT)

      PARAMETER (MAXCPT=20)

      INTEGER CHOICE,NACT(0:MAXCPT)
      DOUBLE PRECISION COMPO(0:MAXCPT)

      INTEGER I,K,INIT_NO_OF_COMPONENTS,FCC
      INTEGER IPHA,INIT_PHASE_NO,ACTL,INITL
      CHARACTER*20 PI,PII
      DOUBLE PRECISION TEMP,PRESS,COMPONENT_X_OF_PHASE

      INITL=1
      ACTL=2

      K=1
      PI='FCC_A1'
      PII=''
      TEMP=1273.0E0
      PRESS=101325.0D0
      IPHA=INIT_PHASE_NO(PI)

      WRITE(*,*) "CONVERTING TO 1 MOLE"

      CALL ONLYNORM(PI,PII,FCC)
      CALL SET_TEMPERATURE(TEMP)
      CALL SET_PRESSURE(PRESS)
      CALL SETCOM(COMPO,CHOICE)
      CALL COMPUTE_EQUILIBRIUM()

c      CALL DISP_RESULT(CHOICE)

      DO 10 I=1,COMPO(0)
         IF (NACT(I).EQ.0) THEN
            COMPO(I)=0
         ELSE
            COMPO(I)=COMPONENT_X_OF_PHASE(I,IPHA,INITL)
         ENDIF
 10   CONTINUE
      
      CHOICE=2
      CALL SETCOM(COMPO,CHOICE)
      CALL COMPUTE_EQUILIBRIUM()
c      CALL DISP_RESULT(2)

      END
C----------------------------------------------------------------------------
C
      SUBROUTINE SHEAR(STIME,DEFMM,TEMP,TTT)
C
      IMPLICIT NONE
      DOUBLE PRECISION DEFM,DEFMM,STIME,TEMP,TTT(8)
C
      DEFM = DABS(DEFMM)
      STIME=DEXP(
     &       (TTT(1)/(8.31432D0*TEMP))
     &       +TTT(2)+TTT(4)*DLOG(TEMP)
     &       +TTT(3)*DLOG(DEFM)
     &            )
      RETURN
      END
C
C----------------------------------------------------------------------------
C
      SUBROUTINE  DIFFU(DTIME,DEFMM,TEMP,TTT)
C
      IMPLICIT NONE
      DOUBLE PRECISION DEFMM,DEFM,DTIME,TEMP,TTT(8)
C
      DEFM = DABS(DEFMM)
      DTIME=DEXP(
     &        (TTT(5)/(8.31432D0*TEMP))
     &        +TTT(6)+TTT(8)*DLOG(TEMP)
     &        +TTT(7)*DLOG(DEFM)
     &            )
      RETURN
      END
C*********************************************************************
